.nh
.TH searchd 1 "September 2021" manticoresearch
.SH OPTIONS
.PP
The options available to \fB\fCsearchd\fR in all operation systems are:

.RS
.IP \(bu 2
\fB\fC--help\fR (\fB\fC-h\fR for short) lists all of the parameters that can be called in your particular build of \fB\fCsearchd\fR\&.
.IP \(bu 2
\fB\fC--version\fR (\fB\fC-v\fR for short) shows Manticore Search version information.
.IP \(bu 2
\fB\fC--config <file>\fR (\fB\fC-c <file>\fR for short) tells \fB\fCsearchd\fR to use the given file as its configuration.
.IP \(bu 2
\fB\fC--stop\fR is used to asynchronously stop \fB\fCsearchd\fR, using the details of the PID file as specified in the Manticore configuration file, so you may also need to confirm to \fB\fCsearchd\fR which configuration file to use with the \fB\fC--config\fR option. Example:

.RE

.PP
.RS

.nf
$ searchd --config /etc/manticoresearch/manticore.conf --stop

.fi
.RE

.RS
.IP \(bu 2
\fB\fC--stopwait\fR is used to synchronously stop \fB\fCsearchd\fR\&. \fB\fC--stop\fR essentially tells the running instance to exit (by sending it a SIGTERM) and then immediately returns. \fB\fC--stopwait\fR will also attempt to wait until the running \fB\fCsearchd\fR instance actually finishes the shutdown (eg. saves all the pending attribute changes) and exits. Example:

.RE

.PP
.RS

.nf
$ searchd --config /etc/manticoresearch/manticore.conf --stopwait

.fi
.RE

.PP
Possible exit codes are as follows:

.RS
.IP \(bu 2
0 on success
.IP \(bu 2
1 if connection to running searchd server failed
.IP \(bu 2
2 if server reported an error during shutdown
.IP \(bu 2
3 if server crashed during shutdown
.IP \(bu 2
\fB\fC--status\fR command is used to query running \fB\fCsearchd\fR instance status using the connection details from the (optionally) provided configuration file. It will try to connect to running instance using the first found UNIX socket or TCP port from the configuration file. On success it will query for a number of status and performance counter values and print them. You can also use SHOW STATUS command to access the very same counters via SQL protocol. Examples:

.RE

.PP
.RS

.nf
$ searchd --status
$ searchd --config /etc/manticoresearch/manticore.conf --status

.fi
.RE

.RS
.IP \(bu 2
\fB\fC--pidfile\fR is used to explicitly force using a PID file (where the \fB\fCsearchd\fR process identification number is stored) despite any other debugging options that say otherwise (for instance, \fB\fC--console\fR). This is a debugging option.

.RE

.PP
.RS

.nf
$ searchd --console --pidfile

.fi
.RE

.RS
.IP \(bu 2
\fB\fC--console\fR is used to force \fB\fCsearchd\fR into console mode; typically Manticore runs as a conventional server application and logs information into log files (as specified in configuration file). Sometimes though, when debugging issues in the configuration or the server itself or trying to diagnose hard-to-track-down problems it may be easier to force it to dump information directly to the console/command line from which it is being called. Running in console mode also means that the process will not be forked (so searches are done in sequence) and logs will not be written to. (It should be noted that console mode is not the intended method for running \fB\fCsearchd\fR\&.)  You can invoke so:

.RE

.PP
.RS

.nf
$ searchd --config /etc/manticoresearch/manticore.conf --console

.fi
.RE

.RS
.IP \(bu 2
\fB\fC--logdebug\fR, \fB\fC--logreplication\fR, \fB\fC--logdebugv\fR, and \fB\fC--logdebugvv\fR options enable additional debug output in the server log. They differ by the logging verboseness level. These are debugging options, they pollute the log a lot, and thus they should \fInot\fP be normally enabled. (The normal use case for these is to enable them temporarily on request, to assist with some particularly complicated debugging session.)
.IP \(bu 2
\fB\fC--iostats\fR is used in conjunction with the logging options (the \fB\fCquery_log\fR will need to have been activated in \fB\fCmanticore.conf\fR) to provide more detailed information on a per-query basis as to the input/output operations carried out in the course of that query, with a slight performance hit and a little bit bigger logs. The IO statistics don't include information about IO operations for attributes, as these are loaded with mmap. To enable it you can start \fB\fCsearchd\fR so:

.RE

.PP
.RS

.nf
$ searchd --config /etc/manticoresearch/manticore.conf --iostats

.fi
.RE

.RS
.IP \(bu 2
\fB\fC--cpustats\fR is used to provide actual CPU time report (in addition to wall time) in both query log file (for every given query) and status report (aggregated). It depends on \fB\fCclock_gettime()\fR Linux system call or falls back to less precise call on certain systems. You might start \fB\fCsearchd\fR thus:

.RE

.PP
.RS

.nf
$ searchd --config /etc/manticoresearch/manticore.conf --cpustats

.fi
.RE

.RS
.IP \(bu 2
\fB\fC--port portnumber\fR (\fB\fC-p\fR for short) is used to specify the port that Manticore should listen on to accept binary protocol requests, usually for debugging purposes. This will usually default to 9312, but sometimes you need to run it on a different port. Specifying it on the command line will override anything specified in the configuration file. The valid range is 0 to 65535, but ports numbered 1024 and below usually require a privileged account in order to run.
An example of usage:

.RE

.PP
.RS

.nf
$ searchd --port 9313

.fi
.RE

.RS
.IP \(bu 2
\fB\fC--listen ( address ":" port | port | path ) [ ":" protocol ]\fR (or \fB\fC-l\fR for short) Works as \fB\fC--port\fR, but allow you to specify not only the port, but full path, as IP address and port, or Unix-domain socket path, that \fB\fCsearchd\fR will listen on. In other words, you can specify either an IP address (or hostname) and port number or just a port number or Unix socket path. If you specify port number, but not the address searchd will listen on all network interfaces. Unix path is identified by a leading slash. As the last param you can also specify a protocol handler (listener) to be used for connections on this socket. Supported protocol values are 'sphinx' and 'mysql' (MySQL protocol used since 4.1).
.IP \(bu 2
\fB\fC--force-preread\fR forbids the server to serve any incoming connection until prereading of index files completes. By default, at startup the server accepts connections while index files are lazy loaded into memory. This opens extends the behavior and makes it wait until the files are loaded.
.IP \(bu 2
\fB\fC--index <index>\fR (or \fB\fC-i <index>\fR for short) forces this instance of \fB\fCsearchd\fR  to only serve the specified index. Like \fB\fC--port\fR, above, this is usually for debugging purposes; more long-term changes would generally be applied to the configuration file itself.
.IP \(bu 2
\fB\fC--strip-path\fR strips the path names from all the file names referenced from the index (stopwords, wordforms, exceptions, etc). This is useful for picking up indexes built on another machine with possibly different path layouts.
.IP \(bu 2
\fB\fC--replay-flags=<OPTIONS>\fR switch can be used to specify a list of extra binary log replay options. The supported options are:
.RS
.IP \(bu 2
\fB\fCaccept-desc-timestamp\fR, ignore descending transaction timestamps and replay such transactions anyway (the default behavior is to exit with an error).
.IP \(bu 2
\fB\fCignore-open-errors\fR, ignore missing binlog files (the default behavior is to exit with an error).
.IP \(bu 2
\fB\fCignore-trx-errors\fR, ignore any transaction errors and skip current binlog file (the default behavior is to exit with an error).
.IP \(bu 2
\fB\fCignore-all-errors\fR, ignore any errors described above (the default behavior is to exit with an error).
Example:

.RE


.RE

.PP
.RS

.nf
$ searchd --replay-flags=accept-desc-timestamp

.fi
.RE

.RS
.IP \(bu 2
\fB\fC--coredump\fR is used to enable saving a core file or a minidump of the server on crash. Disabled by default to speed up of server restart on crash. This is useful for debugging purposes.

.RE

.PP
.RS

.nf
$ searchd --config /etc/manticoresearch/manticore.conf --coredump

.fi
.RE

.RS
.IP \(bu 2
\fB\fC--new-cluster\fR bootstraps a replication cluster and makes the server a reference node with cluster restart protection. On Linux you can also run \fB\fCmanticore_new_cluster\fR\&. It will start Manticore in \fB\fC--new-cluster\fR mode via systemd.
.IP \(bu 2
\fB\fC--new-cluster-force\fR bootstraps a replication cluster and makes the server a reference node bypassing cluster restart protection. On Linux you can also run \fB\fCmanticore_new_cluster --force\fR\&. It will start Manticore in \fB\fC--new-cluster-force\fR mode via systemd.
.IP \(bu 2
\fB\fC--safetrace\fR forces \fB\fCsearchd\fR to only use system backtrace() call in crash reports. In certain (rare) scenarios, this might be a "safer" way to get that report. This is a debugging option.
.IP \(bu 2
\fB\fC--nodetach\fR switch (Linux only) tells \fB\fCsearchd\fR not to detach into background. This will also cause log entry to be printed out to console. Query processing operates as usual. This is a debugging option and might also be useful when you run Manticore in a docker container to capture its output.

.RE

.SH Signals
.PP
\fB\fCsearchd\fR supports a number of signals:

.RS
.IP \(bu 2
SIGTERM - Initiates a clean shutdown. New queries will not be handled, but queries that are already started will not be forcibly interrupted.
.IP \(bu 2
SIGHUP - Initiates indexes rotation. Depending on the value of seamless_rotate setting, new queries might be shortly stalled; clients will receive temporary errors.
.IP \(bu 2
SIGUSR1 - Forces reopen of searchd log and query log files, letting you implement log file rotation.

.RE

.SH Environment variables
.RS
.IP \(bu 2
\fB\fCMANTICORE_TRACK_DAEMON_SHUTDOWN=1\fR enables detailed logging while searchd is shutting down. It's useful in case of some shutdown problems:
.RS
.IP \(bu 2
when Manticore shutdowns too long
.IP \(bu 2
or when it freezes at shutdown

.RE


.RE
